/*

  COPYRIGHT(C) 2004  hardkoder@gmail.com / http://www.kipple.pe.kr
  ۱  :
    -  ҽ  // մϴ.
    - ,  ٰ ϰų ϸ ȵ.
    - ҽ  ãҰų,  Ͽ  ̿   ˷ָ  ﲬ..
	- ڽ α׷  ҽ Ͽ   ڿ ˷ָ  ڰ  Ҳ..

  ҽ  : 
	- .ALZ   ϱ  . 
	- ALZ BZIP2(̶  Ѱ ƴϰ,  CRC   ũ⸦  ), 
	  DEFLATE  ˰ ZIP     .
	  ( bzip2  4.9x  Ͽ, deflate  5.x  Ͽ. 5.x ʹ bzip2 ʹ    )
	- UnAlzBz2decompress.c  UnAlzbzlib.c   bzip2 ҽ alz   
	  ( deflate   ȵǾ  ׳ zlib  ᵵ .. bzip2   Ǿ 
	   bzip2 ҽ ״  ȵȴ. )
	-  ҽ 4ĭ   Ͽ.

   :
    -  ҽ  ÷ Ҽ ְ ϱ ؼ stdio  Ͽ 
	  2GB ̻  óϱ ؼ ¿  WINDOWS I/O Լ  ٲپ.
	-  ϱ ؼ ҽ  ʿϴٸ,  ۾ û ּ.

    :
	2004/02/06	- http://www.wotsit.org/  ZIP File Format Specification version 4.5 [PKWARE Inc.]  
				  ٿε ޾Ƽ м.
	2004/02/07	- ťƮ unzip Ŭ  
	2004/02/08	- unzip Ŭ alzip ˿ ߾   ׽Ʈ
				- deflate, rawdata   .
				- ̾˷α ڽ  .
	2004/02/08	- bzip2  
	2004/03/01	- bzip2  Ϻ  Ҭ
				- callback ..
	2004/03/07	- ƿ Լ ߰ ( ExtractCurrentFileToBuf() )
	2004/10/03	-     ߰ ( FILE I/O    Ŭ  )
	            - 2GB ̻  ó 

   :
	- bzip2     
	- UI  ( PROGRESS,  ޽ ,    )
	-    

	- ȣ ɸ  
	- ջ Ͽ   ׽Ʈ
	-  CRC üũ 

    :
	- bzip2     
	- UI  ( PROGRESS,  ޽ ,    )
	-    
*/


#ifndef _UNALZ_H_
#define _UNALZ_H_

#include <vector>
#include <string>
using namespace std;


#ifndef INT64
#ifdef _WIN32
#	define INT64 __int64
#else
#	define INT64 long long
#endif
#endif

#ifndef DWORD
	typedef unsigned long       DWORD;
#endif // DWORD 
#ifndef SHORT
	typedef short SHORT;
#endif
#ifndef BYTE
	typedef unsigned char       BYTE;
#endif
#ifndef CHAR
	typedef char CHAR;
#endif
#ifndef BYTE
	typedef unsigned char BYTE;
#endif
#ifndef UINT
	typedef unsigned int UINT;
#endif
#ifndef LONG
	typedef long LONG;
#endif
#ifndef BOOL
	typedef int BOOL;
#endif
#ifndef FALSE
#	define FALSE               0
#endif
#ifndef TRUE
#	define TRUE                1
#endif
#ifndef LPCTSTR
	typedef const char* LPCSTR;
#endif
#ifndef HANDLE
#	ifdef _WIN32
	typedef void *HANDLE;
#	else
	typedef FILE *HANDLE;
#	endif
#endif
#ifndef ASSERT
#	include <assert.h>
#	define ASSERT(x) assert(x)
#endif







namespace UNALZ
{

#ifdef _WIN32
#	pragma pack(push, UNALZ, 1)			// structure packing 
#else
#	pragma pack(1)
#endif

static const char UNALZ_VERSION[] = "CUnAlz0.2";
static const char UNALZ_COPYRIGHT[] = "Copyright(C) 2004 hardkoder@gmail.com";


//   ..
struct SAlzHeader
{
	DWORD	unknown;			// ??
};

/*
union _UGeneralPurposeBitFlag			// zip  ..
{
	SHORT	data;
	struct 
	{
		BYTE bit0 : 1;
		BYTE bit1 : 1;
		BYTE bit2 : 1;
		BYTE bit3 : 1;
		BYTE bit4 : 1;
		BYTE bit5 : 1;
	};
};
*/

enum COMPRESSION_METHOD					///<   ..
{
	COMP_NOCOMP = 0,
	COMP_BZIP2 = 1,
	COMP_DEFLATE = 2,
};

struct _SLocalFileHeaderHead			///<   .
{
	SHORT	fileNameLength;
	BYTE	unknown[5];					///<  ???
	BYTE	fileSizeByte;				///<   ũ ʵ ũ : 0x10, 0x20, 0x40, 0x80  1byte, 2byte, 4byte, 8byte
	BYTE	unknown2[1];				///<  ???

	/*
	SHORT	versionNeededToExtract;
	_UGeneralPurposeBitFlag	generalPurposeBitFlag;
	SHORT	compressionMethod;
	SHORT	lastModFileTime;
	SHORT	lastModFileDate;
	DWORD	crc32;
	DWORD	compressedSize;
	DWORD	uncompressedSize;
	SHORT	fileNameLength;
	SHORT	extraFieldLength;
	*/
};

struct _SDataDescriptor
{
	DWORD	crc32;
	DWORD	compressed;
	DWORD	uncompressed;
};

struct SLocalFileHeader
{
	SLocalFileHeader() { memset(this, 0, sizeof(*this)); }
	//~SLocalFileHeader() { if(fileName) free(fileName); if(extraField) free(extraField); }
	void Clear() { if(fileName) free(fileName); fileName=NULL; if(extraField) free(extraField);extraField=NULL; }
	_SLocalFileHeaderHead	head;

	BYTE					compressionMethod;			///<    : 2 - deflate, 1 - bzip2(?), 0 -  .
	BYTE					unknown3[1];				///<  ???
	DWORD					maybeCRC;					///<  Ƹ crc

	INT64					compressedSize;
	INT64					uncompressedSize;

	CHAR*					fileName;
	BYTE*					extraField;
	_SDataDescriptor		dataDescriptor;
	INT64					dwFileDataPos;			///<  file data   ġ..
};

struct _SCentralDirectoryStructureHead
{
	DWORD	dwUnknown;						///<  ׻ NULL ̴..
	DWORD	dwMaybeCRC;						///<  Ƹ crc
	DWORD	dwCLZ03;						///<  "CLZ0x03" - 0x035a4c43  ǥϴµ.
	/*
	SHORT	versionMadeBy;
	SHORT	versionNeededToExtract;
	_UGeneralPurposeBitFlag	generalPurposeBitFlag;
	SHORT	compressionMethod;
	SHORT	lastModFileTime;
	SHORT	lastModFileDate;
	DWORD	crc32;
	DWORD	compressedSize;
	DWORD	uncompressedSize;
	SHORT	fileNameLength;
	SHORT	extraFieldLength;
	SHORT	fileCommentLength;
	SHORT	diskNumberStart;
	SHORT	internalFileAttributes;
	DWORD	externalFileAttributes;
	DWORD	relativeOffsetOfLocalHeader;
	*/
};

struct SCentralDirectoryStructure
{
	SCentralDirectoryStructure() { memset(this, 0, sizeof(*this)); }
	//~SCentralDirectoryStructure() { if(fileName) free(fileName); if(extraField) free(extraField);if(fileComment)free(fileComment); }
	_SCentralDirectoryStructureHead	head;
	/*
	CHAR*	fileName;
	BYTE*	extraField;
	CHAR*	fileComment;
	*/
};


/*
struct _SEndOfCentralDirectoryRecordHead
{
	SHORT	numberOfThisDisk;
	SHORT	numberOfTheDiskWithTheStartOfTheCentralDirectory;
	SHORT	centralDirectoryOnThisDisk;
	SHORT	totalNumberOfEntriesInTheCentralDirectoryOnThisDisk;
	DWORD	sizeOfTheCentralDirectory;
	DWORD	offsetOfStartOfCentralDirectoryWithREspectoTotheStartingDiskNumber;
	SHORT	zipFileCommentLength;
};
*/

/*
struct SEndOfCentralDirectoryRecord
{
	SEndOfCentralDirectoryRecord() { memset(this, 0, sizeof(*this)); }
	~SEndOfCentralDirectoryRecord() { if(fileComment) free(fileComment); }
	_SEndOfCentralDirectoryRecordHead head;
	CHAR*	fileComment;
};
*/

#ifdef _WIN32
#pragma pack(pop, UNALZ)		///<  PACKING  
#else
#pragma pack(4)
#endif


///<  PROGRESS CALLBACK FUNCTION -    Ȳ ˰  ̰  ȴ.
typedef void (_UnAlzCallback)(const char* szMessage, INT64 nCurrent, INT64 nRange, void* param, BOOL* bHalt);


class CUnAlz  
{
public:
	CUnAlz();
	~CUnAlz();
	BOOL	Open(const char* szPathName);
	void	Close();
	BOOL	SetCurrentFile(const char* szFileName);
	BOOL	ExtractCurrentFile(const char* szDestPathName, const char* szDestFileName=NULL);
	BOOL	ExtractCurrentFileToBuf(BYTE* pDestBuf, int nBufSize);
	BOOL	ExtractAll(const char* szDestPathName);
	void	SetCallback(_UnAlzCallback* pFunc, void* param=NULL);

public :			///<  WIN32  ( UNICODE ó )
/*
#ifdef _WIN32
	BOOL	Open(LPCWSTR szPathName);
	BOOL	SetCurrentFile(LPCWSTR szFileName);
	static BOOL		IsFolder(LPCWSTR szPathName);
#endif
*/

public :
	typedef vector<SLocalFileHeader>		FileList;			///<   .
	const FileList&	GetFileList() { return m_fileList; };		///<  file  
	FileList::iterator GetCurFileHeader() { return m_posCur; };	///<   (SetCurrentFile()  õ)  
//	const SLocalFileHeader* GetCurFileHeader() { return _posCur; };	///<   (SetCurrentFile()  õ)  

public :
	enum ERR							///<  ڵ -  ʿ..
	{
		ERR_NOERR,
		ERR_CANT_OPEN_FILE,				///<    
		ERR_CANT_READ_SIG,				///<  signature б 
		ERR_CANT_READ_FILE,

		ERR_AT_READ_HEADER,
		ERR_INVALID_FILENAME_LENGTH,
		ERR_INVALID_EXTRAFIELD_LENGTH,
		ERR_CANT_READ_CENTRAL_DIRECTORY_STRUCTURE_HEAD, 
		ERR_INVALID_FILENAME_SIZE,
		ERR_INVALID_EXTRAFIELD_SIZE,
		ERR_INVALID_FILECOMMENT_SIZE,
		ERR_CANT_READ_HEADER,
		ERR_MEM_ALLOC_FAILED,
		ERR_FILE_READ_ERROR,
		ERR_INFLATE_FAILED,
	};
	ERR		GetLastErr(){return m_nErr;}

	enum SIGNATURE							///<  zip file signature
	{
		SIG_ERR								= 0x00,
		SIG_EOF								= 0x01,
		SIG_ALZ_FILE_HEADER					= 0x015a4c41,	///<  ALZ 0x01
		SIG_LOCAL_FILE_HEADER				= 0x015a4c42,	///<  BLZ 0x01
		SIG_CENTRAL_DIRECTORY_STRUCTURE		= 0x015a4c43,	///<  CLZ 0x01
		SIG_ENDOF_CENTRAL_DIRECTORY_RECORD	= 0x025a4c43,	///<  CLZ 0x02
	};

public :
	static BOOL			DigPath(const char* szPathName);
	static BOOL			IsFolder(LPCSTR szPathName);
	static const char*	GetVersion() { return UNALZ_VERSION; }
	static const char*	GetCopyright() { return UNALZ_COPYRIGHT; }

private :
	SIGNATURE	ReadSignature();
	BOOL		ReadAlzFileHeader();
	BOOL		ReadLocalFileheader();
	BOOL		ReadCentralDirectoryStructure();
	BOOL		ReadEndofCentralDirectoryRecord();

private :
	enum EXTRACT_TYPE				///<     Ÿ.
	{
		ET_FILE,					///<  FILE*
		ET_MEM,						///<  memory buffer
	};
	struct		SExtractDest		///<    .
	{
		SExtractDest() { memset(this, 0, sizeof(SExtractDest)); }
		EXTRACT_TYPE nType;			///<   ΰ  ޸ ΰ..
		FILE*		fp;				///<  ET_FILE    FILE*
		BYTE*		buf;			///<  ET_MEM    
		DWORD		bufsize;		///<  ET_MEM     ũ
		DWORD		bufpos;			///<  ET_MEM    ۿ  ִ ġ
	};
	int			WriteToDest(SExtractDest* dest, BYTE* buf, int nSize);

private :
	BOOL		ExtractTo(SExtractDest* dest);

	//BOOL		ExtractDeflate(FILE* fp, SLocalFileHeader& file);
	//BOOL		ExtractBzip2_bak(FILE* fp, SLocalFileHeader& file); - (߸)  
	BOOL		ExtractDeflate2(SExtractDest* dest, SLocalFileHeader& file);
	BOOL		ExtractBzip2(SExtractDest* dest, SLocalFileHeader& file);
	BOOL		ExtractRawfile(SExtractDest* dest, SLocalFileHeader& file);

private :		// bzip2  ó Լ..
	typedef void MYBZFILE;
	MYBZFILE*	BZ2_bzReadOpen(int* bzerror, CUnAlz* f, int verbosity, int _small, void* unused, int nUnused);
	int			BZ2_bzread(MYBZFILE* b, void* buf, int len );
	int			BZ2_bzRead(int* bzerror, MYBZFILE* b, void* buf, int len);
	void		BZ2_bzReadClose( int *bzerror, MYBZFILE *b );

private :		//    ó  (lapper?) Ŭ
	BOOL		FOpen(const char* szPathName);
	void		FClose();
	INT64		FTell();
	BOOL		FEof();
	BOOL		FSeek(INT64 offset);
	BOOL		FRead(void* buffer, DWORD nBytesToRead, int* pTotRead=NULL);

	enum		{MAX_FILES=1000};								///< ó     .
	enum		{MULTIVOL_TAIL_SIZE=16,MULTIVOL_HEAD_SIZE=8};	///<   ö,  ũ 
	struct SFile												///<   
	{
		HANDLE	fp;
		INT64	nFileSize;
		int		nMultivolHeaderSize;
		int		nMultivolTailSize;
	};

	SFile		m_files[MAX_FILES];								///<    array - Ѱ?
	int			m_nCurFile;										///< m_files   ó  ġ.
	int			m_nFileCount;									///<   ..
	INT64		m_nVirtualFilePos;								///< Ƽ  ġ
	INT64		m_nCurFilePos;									///<    ġ.
	BOOL		m_bIsEOF;										///<   (  ؼ) Գ?


private :
	FileList			m_fileList;								///<    
	ERR					m_nErr;
	FileList::iterator	m_posCur;								///<  
	_UnAlzCallback*		m_pFuncCallBack;
	void*				m_pCallbackParam;
	BOOL				m_bHalt;
};
}

using namespace UNALZ;

#endif
